#ifndef MY_MATRIX
#define MY_MATRIX


template<class T>
class MyMatrix {
  public:
    // Constructor
    MyMatrix();
    MyMatrix(T** data, unsigned int siz_x, unsigned int siz_y);
    // Destructor
    ~MyMatrix();
    
    // Access method to pixel values
    const T getPixVal(int x, int y) const;
    
    // Access to whole data block
    T** getData() const;
    
    // resize Matrix (changes _data!)
    //  factor has to be <1, otherwise nothing is changed
    void resize_simple(float factor);
    
    // minimum value
    T min_value(unsigned short x1, unsigned short x2, unsigned short y1, unsigned short y2) const;

    // maximum value
    T max_value(unsigned short x1, unsigned short x2, unsigned short y1, unsigned short y2) const;

    //void setPixVal(int x, int y, T value);
    
  protected:

  private:
    // matrix data
    T** _data;
    // size
    unsigned int _siz_x, _siz_y;

};


#endif
